
#include "eyd_uncompressor.hh"

namespace EydLib {

	/*
	   class BitUncompressor {
	   private:
	   BitGroup _last_group;
	   int _last_count;
	   std::list<BitGroup> _uncompressed;

	   public:
	   BitUncompressor();

	   void clear();
	   void append(BitGroup bg);
	   std::list<BitGroup> flush();
	   bool hasContent();
	   };
	   */

	BitUncompressor::BitUncompressor(int size) : _rle(size) {
		_group_size = size;
		_last_count = 0;
		_status = UNCOMPRESSOR_STATUS_NORMAL;
	}

	void BitUncompressor::clear(){
		// we clear everything
		_last_count = 0;
		_uncompressed.clear();
	}

	void BitUncompressor::append(BitGroup data){
		switch (_status){
			case UNCOMPRESSOR_STATUS_NORMAL: 
				printf("STATUS NORMAL : %s\n", data.toString().c_str());
				if (data == _rle){
					// on change le status et on n'crit rien
					_status = UNCOMPRESSOR_STATUS_GOTRLE;
				} else {
					// on crit directement le resultat non dcompress	
					_uncompressed.push_back(data);
				}
				break;
			case UNCOMPRESSOR_STATUS_GOTRLE:
				printf("STATUS GOT RLE : %s\n", data.toString().c_str() );
				if (data == _rle){
					// deux RLE c'est 1 RLE 
					// on crit juste un RLE
					_uncompressed.push_back(data);
					_status = UNCOMPRESSOR_STATUS_NORMAL;
				} else {
					// un RLE et un diffrent c'est une longueur
					// sauf si gal  1 ou 2
					_status = UNCOMPRESSOR_STATUS_GOTLEN; // sauf si gal  RLE
					_last_count = data.getValue(); // on stocke la value
				}
				break;
			case UNCOMPRESSOR_STATUS_GOTLEN:
				printf("STATUS GOT LEN : %s\n", data.toString().c_str() );
				// ce qu'on lit est la valeur
				// on crit donc _last_count fois data
				for (int i=0; i<_last_count; i++){
					_uncompressed.push_back(data);
				}
				_status = UNCOMPRESSOR_STATUS_NORMAL;
				_last_count = 0;
				break;

		}
	}

	std::list<BitGroup> BitUncompressor::flush(){
		// we add the data from _last* to the outlist
		std::list<BitGroup> result;
		result = _uncompressed;
		_uncompressed.clear();
		return result;
	}

	bool BitUncompressor::hasContent(){
		return (!_uncompressed.empty());
	}
}

